---
Name: "bios-lenovo-configuration"
Description: "Configure the lenovo system through batch onecli"
Meta:
  icon: "money"
  color: "grey"
  title: "RackN Content"
RequiredParams:
  - bios-lenovo-configuration
Prerequisites:
  - bios-tools-install
Templates:
  - Name: "bios-lenovo-config.sh"
    Contents: |
      #!/usr/bin/env bash

      {{ template "setup.tmpl" . }}

      onecli=/opt/OneCli/OneCli
      ensure_onecli() {
        which $onecli &>/dev/null && return 0
        echo "Lenovo system detected, but no $onecli binary present."
        echo "Please rework your configure workload to make sure the"
        echo "hardware-tools-install stage is before this stage."
        echo
        echo "This task cannot guarantee that remote access is enabled on this system without it."
        return 1
      }
      ensure_onecli || exit 1

      {{ range $index, $tmpl := .Param "bios-lenovo-configuration" }}
      cat > file.{{$index}} <<EOF
      {{$tmpl}}
      EOF

      set +e
      egrep '\-\-file[ =].[^ ]*' file.{{$index}} | sed -e 's/^.*--file[\t =]\([^ ]*\).*$/\1/g' | while read file
      do
          dir=`dirname $file`
          mkdir -p $dir
          if [[ ! -e $file ]] ; then
              set -e
              wget -O $file {{ $.ParamExpand "bios-file-base-url" }}/$file
              set +e
          fi
      done

      echo "Update item {{$index}}"
      grep -q IMM.SNMPAlerts_SystemAlertCategory file.{{$index}}
      HAS_SAC=$?
      if [[ "$HAS_SAC" != "0" ]] ; then
        grep -q IMM.SSL_CLIENT_TRUSTED_CERT1 file.{{$index}}
        HAS_SAC=$?
      fi
      set -e
      if ! $onecli config batch --file file.{{$index}} --override ; then
        if [[ "$HAS_SAC" == "0" ]] ; then
          echo "Failed to run the script - but has known Lenovo bug - assuming success..."
        else
          echo "Failed to run the script."
          exit 1
        fi
      fi
      rm -f file.{{$index}}
      {{ end }}

      # De-Assert presence
      $onecli rpp deassert || true

      echo "sleep 30s for deassert to finish"
      sleep 30

      echo "Update complete"
      exit 0
